<?php
/**
 * @package   System plugin for redirection with message
 * @version   0.0.1
 * @author    https://www.brainforge.co.uk
 * @copyright Copyright (C) 2020-2022 Jonathan Brain. All rights reserved.
 * @license   GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */

// no direct access
defined('_JEXEC') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Uri\Uri;

class plgSystemBfredirect extends CMSPlugin {
	protected $app;

	/**
	 */
	public function onAfterInitialise()
	{
		if (!$this->app->isClient('site'))
		{
			return;
		}

		$redirect = $this->params->get('redirect');
		if (empty($redirect))
		{
			return;
		}

		$uri = Uri::getInstance();
		$base = $uri->base(true);
		$path = explode('/', trim(substr($uri->getPath(), strlen($base)), '/'));
		switch (count($path))
		{
			case 1:
				if (empty($path[0]))
				{
					return;
				}
				array_unshift($path, 'index.php');
				break;
			default:
				break;
		}

		$name = $this->params->get('name', 'plg_system_bfredirect');

		switch($name)
		{
			case $path[0]:
				unset($path[0]);
				break;
			case 'index.php':
			case '/':
				break;
			default:
				return;
		}

		$label = implode('/', $path);

		foreach((array) $redirect as $redirectWithMessage)
		{
			if (empty($redirectWithMessage->state) || $redirectWithMessage->label != $label)
			{
				continue;
			}

			if (!empty($redirectWithMessage->messagetype))
			{
				$this->app->enqueueMessage(Text::_($redirectWithMessage->message), $redirectWithMessage->messagetype);
			}

			$this->app->redirect($base . '/' . ltrim($redirectWithMessage->target, '/'));
		}
	}
}
